#include <bits/stdc++.h>

const int N = 1e4 + 7;


using namespace std;

bool isPrime(int v) {
	for(int i = 2; i * i <= v; ++i) {
		if(v % i == 0) return false;
	}
	return true;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n;
	cin >> n;
	
	vector<int> primes;
	for(int i = 2; i <= n; ++i) {
		if (isPrime(i)) primes.push_back(i);
	}
	
	vector<long long> dp(primes.size());
	dp[0] = 1;
	
	for(int i = 1; i < primes.size(); ++i) {
		for(int j = 0; j < i; ++j) {
			if(primes[i] - primes[j] > 14) continue;
			dp[i] += dp[j];
		}
	}
	
	cout << dp.back() << '\n';
	
}
