#include <bits/stdc++.h>

using namespace std;

void solve()
{
	long long n;
	cin >> n;
	
	set <long long> divisors;
	
	for (long long i = 1; i * i <= n; ++i)
	{
		if (n % i == 0)
		{
			divisors.insert(i);
			divisors.insert(n / i);
		}
	}
	
	long long ok = 0;
	
	for (auto& d : divisors)
	{
		if (ok + 1 < d)
		{
			cout << "No\n";
			return;
		}
		
		ok = d + ok;
	}

	cout << "Yes\n";
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int t;
	cin >> t;
	
	while(t--)
	{
		solve();
	}
}
